package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineSymbolPrice struct {
	api.Api
}

// GetPage 获取缓存价格交易对列表
// @Summary 获取缓存价格交易对列表
// @Description 获取缓存价格交易对列表
// @Tags 缓存价格交易对
// @Param symbol query string false "交易对"
// @Param status query int false "状态 1-启用 2-禁用"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineSymbolPrice}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-symbol-price [get]
// @Security Bearer
func (e LineSymbolPrice) GetPage(c *gin.Context) {
    req := dto.LineSymbolPriceGetPageReq{}
    s := service.LineSymbolPrice{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineSymbolPrice, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取缓存价格交易对失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取缓存价格交易对
// @Summary 获取缓存价格交易对
// @Description 获取缓存价格交易对
// @Tags 缓存价格交易对
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineSymbolPrice} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-symbol-price/{id} [get]
// @Security Bearer
func (e LineSymbolPrice) Get(c *gin.Context) {
	req := dto.LineSymbolPriceGetReq{}
	s := service.LineSymbolPrice{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineSymbolPrice

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取缓存价格交易对失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建缓存价格交易对
// @Summary 创建缓存价格交易对
// @Description 创建缓存价格交易对
// @Tags 缓存价格交易对
// @Accept application/json
// @Product application/json
// @Param data body dto.LineSymbolPriceInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-symbol-price [post]
// @Security Bearer
func (e LineSymbolPrice) Insert(c *gin.Context) {
    req := dto.LineSymbolPriceInsertReq{}
    s := service.LineSymbolPrice{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建缓存价格交易对失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改缓存价格交易对
// @Summary 修改缓存价格交易对
// @Description 修改缓存价格交易对
// @Tags 缓存价格交易对
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineSymbolPriceUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-symbol-price/{id} [put]
// @Security Bearer
func (e LineSymbolPrice) Update(c *gin.Context) {
    req := dto.LineSymbolPriceUpdateReq{}
    s := service.LineSymbolPrice{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改缓存价格交易对失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除缓存价格交易对
// @Summary 删除缓存价格交易对
// @Description 删除缓存价格交易对
// @Tags 缓存价格交易对
// @Param data body dto.LineSymbolPriceDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-symbol-price [delete]
// @Security Bearer
func (e LineSymbolPrice) Delete(c *gin.Context) {
    s := service.LineSymbolPrice{}
    req := dto.LineSymbolPriceDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除缓存价格交易对失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
